## mingw-w64-tixi-3.3.0-3.src.tar.zst

=== bindings/fortran03/CMakeLists.txt ===

# work around wrong python detection script of cmake (happens with old python versions)
if(PYTHON_EXECUTABLE)
    execute_process(COMMAND "${PYTHON_EXECUTABLE}" --version
                    ERROR_VARIABLE _VERSION
                    RESULT_VARIABLE _PYTHON_VERSION_RESULT
                    OUTPUT_QUIET
                    ERROR_STRIP_TRAILING_WHITESPACE)
    if(_PYTHON_VERSION_RESULT)
        execute_process(COMMAND "${PYTHON_EXECUTABLE}" -V
                        ERROR_VARIABLE _VERSION
                        RESULT_VARIABLE _PYTHON_VERSION_RESULT
                        OUTPUT_QUIET
                        ERROR_STRIP_TRAILING_WHITESPACE)
    endif(_PYTHON_VERSION_RESULT)
    if(NOT _PYTHON_VERSION_RESULT AND _VERSION MATCHES "^Python [0-9]+\\.[0-9]+.*")
        string(REPLACE "Python " "" PYTHON_VERSION_STRING "${_VERSION}")
        string(REGEX REPLACE "^([0-9]+)\\.[0-9]+.*" "\\1" PYTHON_VERSION_MAJOR "${PYTHON_VERSION_STRING}")
        string(REGEX REPLACE "^[0-9]+\\.([0-9])+.*" "\\1" PYTHON_VERSION_MINOR "${PYTHON_VERSION_STRING}")
        if(PYTHON_VERSION_STRING MATCHES "^[0-9]+\\.[0-9]+\\.[0-9]+.*")
            string(REGEX REPLACE "^[0-9]+\\.[0-9]+\\.([0-9]+).*" "\\1" PYTHON_VERSION_PATCH "${PYTHON_VERSION_STRING}")
        endif()
    endif()
endif(PYTHON_EXECUTABLE)

if(PYTHONINTERP_FOUND AND NOT PYTHON_VERSION_STRING VERSION_LESS "2.5" )
    #run python to create the wrapper
    add_custom_command(
        OUTPUT ${LIBRARY_OUTPUT_PATH}/${TIXI_LIB_NAME}.f90
        DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/make_tixi_fortran03.py
                ${PROJECT_SOURCE_DIR}/src/tixi.h
                ${PROJECT_SOURCE_DIR}/bindings/bindings_generator/cheader_parser.py
                ${PROJECT_SOURCE_DIR}/bindings/bindings_generator/fortran03_generator.py
        WORKING_DIRECTORY ${LIBRARY_OUTPUT_PATH}
        COMMAND ${PYTHON_EXECUTABLE}
        ARGS ${CMAKE_CURRENT_SOURCE_DIR}/make_tixi_fortran03.py
    )

    add_custom_target(tixiFortran03 ALL
        COMMENT "Create Fortran 2003 interface for tixi" VERBATIM
        DEPENDS ${LIBRARY_OUTPUT_PATH}/${TIXI_LIB_NAME}.f90
    )

    if(TIXI_BUILD_TESTS AND NOT CMAKE_Fortran_COMPILER STREQUAL CMAKE_Fortran_COMPILER-NOTFOUND AND CMAKE_Fortran_COMPILER)
      enable_language(Fortran)
      
      add_executable(wrappertestsF03 wrappertests.F90 ${LIBRARY_OUTPUT_PATH}/${TIXI_LIB_NAME}.f90)
      target_compile_definitions(wrappertestsF03 PRIVATE TIXI_VERSION="${TIXI_VERSION}")
      target_link_libraries(wrappertestsF03 ${TIXI_LIB_NAME})
      set_target_properties(wrappertestsF03 PROPERTIES
          RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/tests
      )
    endif()

    install(FILES ${LIBRARY_OUTPUT_PATH}/${TIXI_LIB_NAME}.f90
            DESTINATION share/${TIXI_LIB_NAME}/fortran03
            COMPONENT interfaces
    )
else()
    message(WARNING "Python could not be found or the python installation is too old ( < 2.5). Fortran03 bindings will not be build!")
endif()

=== bindings/matlab/CMakeLists.txt ===
# Matlab bindings for tixi
# @author Martin Siggel

find_package(MATLAB QUIET)

if(PYTHONINTERP_FOUND)
message(STATUS "TiXI MATLAB interface files are created (*.m, tiximatlab.c).")

#run python to create the tiglmatlab.c
add_custom_command(
        OUTPUT ${TIXI_LIB_NAME}matlab.c
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/make_tixi_matlab.py ${PROJECT_SOURCE_DIR}/src/tixi.h
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
    COMMAND ${PYTHON_EXECUTABLE}
    ARGS ${CMAKE_CURRENT_SOURCE_DIR}/make_tixi_matlab.py
)

add_custom_target(tixi_mex_interface ALL
    COMMENT "Create MATLAB mex source for tixi" VERBATIM
        DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/${TIXI_LIB_NAME}matlab.c
)

configure_file(Makefile.in ${CMAKE_CURRENT_BINARY_DIR}/Makefile-matlab @ONLY)

install(
    CODE "file( GLOB MFILES ${CMAKE_CURRENT_BINARY_DIR}/*.m )"
    CODE "file( INSTALL \${MFILES} DESTINATION \${CMAKE_INSTALL_PREFIX}/share/${TIXI_LIB_NAME}/matlab )"
    COMPONENT interfaces
)

install(FILES
    ${CMAKE_CURRENT_BINARY_DIR}/${TIXI_LIB_NAME}matlab.c
    ${CMAKE_CURRENT_SOURCE_DIR}/common.h
    ${CMAKE_CURRENT_SOURCE_DIR}/Readme.md
    DESTINATION share/${TIXI_LIB_NAME}/matlab
    COMPONENT interfaces
)

# We cannot directly create a Makefile, as it would collide with cmake's makefile
# Hence, we are renaming it after installation
install(FILES
    ${CMAKE_CURRENT_BINARY_DIR}/Makefile-matlab
    RENAME Makefile
    DESTINATION share/${TIXI_LIB_NAME}/matlab
    COMPONENT interfaces
)

if(MATLAB_FOUND)
    # If matlab is found, the tiximatlab.c file is compiled into a
    # mex file and is installed

    message(STATUS "MATLAB found: TiXI mex file will be build.")

    # c wrapper code
    set(TMAT_SRC ${TIXI_LIB_NAME}matlab.c common.h)

    # add def for exports
    if(MSVC)
      set(TMAT_SRC ${TMAT_SRC} exports.def)
    endif()


    add_library(${TIXI_LIB_NAME}_matlab SHARED ${TMAT_SRC})
    target_include_directories(${TIXI_LIB_NAME}_matlab PRIVATE
        ${MATLAB_INCLUDE_DIR}
        ${CMAKE_CURRENT_SOURCE_DIR}
    )
    target_link_libraries(${TIXI_LIB_NAME}_matlab PRIVATE
        ${MATLAB_mat_LIBRARY} ${MATLAB_mx_LIBRARY} ${MATLAB_mex_LIBRARY} ${TIXI_LIB_NAME}
    )
    set_target_properties(${TIXI_LIB_NAME}_matlab PROPERTIES SUFFIX ${MATLAB_MEX_SUFFIX} PREFIX "")

    install(TARGETS ${TIXI_LIB_NAME}_matlab DESTINATION share/${TIXI_LIB_NAME}/matlab
        COMPONENT interfaces
    )
else(MATLAB_FOUND)
        message(STATUS "MATLAB not found: The TiXI mex is not created. It can still be build using the generated ${TIXI_LIB_NAME}matlab.c file.")
endif(MATLAB_FOUND)
    
endif() # python found

=== PKGBUILD ===
# Contributor: Melven Roehrig-Zoellner <Melven.Roehrig-Zoellner@DLR.de>

_realname=tixi
pkgbase=mingw-w64-${_realname}
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgver=3.3.0
pkgrel=3
pkgdesc="TiXI is a fast and simple XML interface library (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url='https://github.com/DLR-SC/tixi'
license=('spdx:Apache-2.0')
depends=("${MINGW_PACKAGE_PREFIX}-curl"
         "${MINGW_PACKAGE_PREFIX}-libxml2"
         "${MINGW_PACKAGE_PREFIX}-libxslt")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-fc"
             "${MINGW_PACKAGE_PREFIX}-python")
conflicts=("${MINGW_PACKAGE_PREFIX}-tixi3")
replaces=("${MINGW_PACKAGE_PREFIX}-tixi3")
provides=("${MINGW_PACKAGE_PREFIX}-tixi3")
source=("https://github.com/DLR-SC/tixi/archive/v${pkgver}/${_realname}-${pkgver}.tar.gz"
        0001-Dont-build-and-install-the-examples.patch
        0002-Fix-ctypes-DLL-loading-in-Python-3.8-new-policy.patch
        0003-fix-build-with-latest-libxml2.patch::https://github.com/DLR-SC/tixi/commit/732f6ad3.patch)
sha256sums=('988d79ccd53c815d382cff0c244c0bb8e393986377dfb45385792766adf6f6a9'
            'b3411df0057eef3b8fa4c56e432bf90938fedc0833d3cce9d9c66fbcb7101c42'
            '9ef13729efb68420f869e21259bce492ee4c66e624bbe5901abe296f56fafc6a'
            'a87bd7a4ea402bebb298065cd603aa7de291c39b96a2930c30011f88b3740d5f')

prepare() {
  cd "${srcdir}/${_realname}-${pkgver}"
  patch -Np1 -i "${srcdir}/0001-Dont-build-and-install-the-examples.patch"
  patch -Np1 -i "${srcdir}/0002-Fix-ctypes-DLL-loading-in-Python-3.8-new-policy.patch"
  dos2unix "${srcdir}"/0003-fix-build-with-latest-libxml2.patch
  patch -Np1 -i "${srcdir}/0003-fix-build-with-latest-libxml2.patch"
}


build() {
  mkdir -p "${srcdir}"/build-${MSYSTEM} && cd "${srcdir}"/build-${MSYSTEM}

  declare -a extra_config
  if check_option "debug" "n"; then
    extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi
  
  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    ${MINGW_PREFIX}/bin/cmake \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
      -DCMAKE_DLL_NAME_WITH_SOVERSION=ON \
      -DCMAKE_POLICY_VERSION_MINIMUM=3.5 \
      -DTIXI_ENABLE_FORTRAN=ON \
      -DBUILD_SHARED_LIBS=ON \
      "${extra_config[@]}" \
      ../${_realname}-${pkgver}

  ${MINGW_PREFIX}/bin/cmake --build .
}


package() {
  cd "${srcdir}"/build-${MSYSTEM}

  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake --build . --target install

  install -Dm644 "${srcdir}/${_realname}-${pkgver}/LICENSE" \
    "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE"
}
